#include "nausea.h"



tstr tdocument::descript(tstr s)
{
	tstr res="";
	bool inside=false;
	for(unsigned i=0;i<s.length();i++)
	{
		if((s.substr(i,7)=="<script"||s.substr(i,7)=="<SCRIPT")&&!inside)
			inside=true;
		if(inside&&(s.substr(i,9)=="</SCRIPT>"||s.substr(i,9)=="</script>"))
			{inside=false;i+=8;res+=" ";continue;}
		if(!inside)
			res+=s[i];
	}
	return res;
}

tstr tdocument::destyle(tstr s)
{
	tstr res="";
	bool inside=false;
	for(unsigned i=0;i<s.length();i++)
	{
		if((s.substr(i,6)=="<style"||s.substr(i,6)=="<STYLE")&&!inside)
			inside=true;
		if(inside&&(s.substr(i,8)=="</style>"||s.substr(i,8)=="</STYLE>"))
			{inside=false;i+=7;res+=" ";continue;}
		if(!inside)
			res+=s[i];
	}
	return res;
}

tstr tdocument::detag(tstr s)
{
	tstr res="";
	bool inside=false;
	for(unsigned i=0;i<s.length();i++)
	{
		if(s[i]=='<'&&!inside)
			inside=true;
		if(inside&&s[i]=='>')
			{inside=false;res+=" ";continue;}
		if(!inside)
			res+=s[i];
	}
	return res;
}

tstr tdocument::deshit(tstr s)
{
	tstr res="";
	for(unsigned i=0;i<s.length();i++)
	{

		if(s.substr(i,6)=="&nbsp;"||s.substr(i,6)=="&NBSP;")
		{
			i+=5;res+=" ";continue;
		}
		if(s.substr(i,5)=="&nbsp"||s.substr(i,5)=="&NBSP")
		{
			i+=4;res+=" ";continue;
		}
		if(s.substr(i,6)=="&bull;"||s.substr(i,6)=="&BULL;")
		{
			i+=5;res+=" ";continue;
		}
		if(s.substr(i,8)=="&middot;"||s.substr(i,8)=="&MIDDOT;")
		{
			i+=7;res+=" ";continue;
		}
		if(s.substr(i,7)=="&mdash;"||s.substr(i,7)=="&MDASH;")
		{
			i+=6;res+=" ";continue;
		}
		if(s.substr(i,7)=="&laquo;"||s.substr(i,7)=="&LAQUO;")
		{
			i+=6;res+=" ";continue;
		}
		if(s.substr(i,7)=="&raquo;"||s.substr(i,7)=="&RAQUO;")
		{
			i+=6;res+=" ";continue;
		}
		if(s.substr(i,7)=="&minus;"||s.substr(i,7)=="&MINUS;")
		{
			i+=6;res+=" ";continue;
		}
		if(s.substr(i,2)=="&#")
		{
			//    ";"
			i+=2;
			while((s[i]>='0'&&s[i]<='9'||s[i]==';')&&i<s.length())
				i++;
			res+=" ";i--;continue;
		}
		bool allowed=false;
		for(unsigned j=0;j<allowedchars.length();j++)
			if(s[i]==allowedchars[j])
				{ res+=s[i]; allowed=true; }
		if(!allowed)
			res+=" ";
	}
	return res;
}

tstr tdocument::allowedchars=" abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZŨ0123456789";

tdocument::tdocument(tstr s)
{
/*
        try
        {
	        std::ifstream infile("allowedchars");
		infile>>allowedchars;
	}
	catch(std::ios_base::failure &var)
	{
    		throw (char*)var.what();
	}
*/

	body=s;
	s=destyle(s);
	s=descript(s);
	s=detag(s);
	s=deshit(s);
	tnorm norm;
	tstr ns=norm[s];
	tstr word;
	int st=0,nst=0;
	while((word=getword(ns)).length())
	{
		nst++;
		tstr form=getword(s); //!!!
		st++;
		std::vector<tstr> norms;
		while(word.find("|")!=tstr::npos)
		{
			tstr norm=word.substr();
			norms.push_back(word.substr(0,word.find("|")));
			word.erase(0,word.find("|")+1);
		}
		norms.push_back(word);

		bool found=false;
		tstr shortest=norms[0]; tstr last=norms[0];
		for(std::vector<tstr>::iterator i=norms.begin();i!=norms.end();i++)
		{
			if(words.count(*i)!=0)
				{word=*i;found=true;break;}
			if(i->length()<shortest.length())
				shortest=*i;
			last=*i;
		}
		if(!found)
//			word=shortest;
			word=last;

		words[word][form]++;
	}
}

pvector tdocument::getsorted()
{
	pvector res;

	for(twords::iterator i=words.begin();i!=words.end();i++)
	{
		pair p;
		p.word=i->first;
		p.count=total(words[i->first]);
		res.push_back(p);
	}	

	std::sort(res.begin(),res.end());

	return res;
}

pvector tdocument::getforms(tstr s)
{
	pvector res;

	for(tforms::iterator i=words[s].begin();i!=words[s].end();i++)
	{
		pair p;
		p.word=i->first;
		p.count=i->second;
		res.push_back(p);
	}	

	std::sort(res.begin(),res.end());

	return res;
}

tstr getword(tstr& s)
{
	tstr res="";
	//  
	while(s[0]==' '||s[0]=='\t'||s[0]=='\n')
	    s.erase(0,1);
	//     
	while(s.length()>0&&s[0]!=' '&&s[0]!='\t'&&s[0]!='\n')
	{
		res+=s[0];
		s.erase(0,1);
	}
	return res;
}

int total(tforms& f)
{
	int c=0;
	for(tforms::iterator i=f.begin();i!=f.end();i++)
		c+=i->second;
	return c;
}
